// generated 2004/12/16 14:54:44 CET by arno@debian.mgeintra.com.(none)
// using glademm V2.5.0
//
// newer (non customized) versions of this file go to AboutView.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "gettext.h"
#include "AboutView.hh"


AboutView::AboutView()
  :View("about")
{ 
  std::ostringstream oss; 

  // Complete PSP general info
  oss << MFR_NAME << _("\nPersonal Solution Pac for Linux\nVersion ") << VERSION;
  lblPspInfo->set_text (oss.str());
  lblPspInfo->set_justify(Gtk::JUSTIFY_CENTER);

	oss.str(""); // reinit the string

  // Complete copyright info (for year)  
  oss << "Copyright (C) 2008 - " << MFR_NAME << _("\nDistributed under the terms of the GPL v2");
  lblCopyright->set_text (oss.str());

  nutInfoFilled = false;
}

AboutView::AboutView(Glib::ustring &nutVersion, Glib::ustring &driverName, Glib::ustring &driverVersion)
  :View("about")
{
  std::ostringstream oss; 

  // Complete PSP general info
  oss << MFR_NAME << _("\nPersonal Solution Pac for Linux\nVersion ") << VERSION;
  lblPspInfo->set_text (oss.str());
  lblPspInfo->set_justify(Gtk::JUSTIFY_CENTER);

	oss.str(""); // reinit the string

  // Complete copyright info (for year)  
  oss << "Copyright (C) 2008 - " << MFR_NAME << _("\nDistributed under the terms of the GPL v2");
  lblCopyright->set_text (oss.str());

  nutInfoFilled = false;

  // Complete NUT information
  setNutInfo(nutVersion, driverName, driverVersion);
}


void AboutView::setNutInfo(Glib::ustring &nutVersion, Glib::ustring &driverName, Glib::ustring &driverVersion)
{
  // Complete NUT information (release, driver name and version)
  Glib::ustring currentText = lblAboutNut->get_text ();
  
  currentText.append(_("\tNUT release: ") + nutVersion + "\n");
  currentText.append(_("\tNUT driver: ") + driverName);
  currentText.append(" (version: " + driverVersion + ")\n");
  
  // Update the text content
  lblAboutNut->set_text (currentText);
  
  nutInfoFilled = true;
}


void AboutView::setFont(const Glib::ustring fontName)
{
  lblPspInfo->modify_font(Pango::FontDescription(fontName));
  lblCopyright->modify_font(Pango::FontDescription(fontName));
  lblAboutNut->modify_font(Pango::FontDescription(fontName));
  lblAboutPsp->modify_font(Pango::FontDescription(fontName));
}

