// generated 2005/3/10 10:51:14 CET by arno@debian.mgeintra.com.(none)
// using glademm V2.5.0
//
// newer (non customized) versions of this file go to EventWin.hh_new

// you might replace
//    class foo : public foo_glade { ... };
// by
//    typedef foo_glade foo;
// if you didn't make any modifications to the widget

#ifndef _EVENTWIN_HH
#  include "EventWin_glade.hh"
#  include <gtkmm.h>
#  define _EVENTWIN_HH


class EventWin : public EventWin_glade
{  
  // This class will roll and display the last 10 events,
  // timestamping these upon addEvent, and putting the
  // text and severity (bul green/yellow/red) according
  // to the configuration (FIXME: which config?)

public:
  EventWin(Glib::ustring initialStatus);

  // 
  void addEvent(Glib::ustring eventName, int evtSeverity=SEVERITY_NORMAL);
  void setFont(const Glib::ustring fontName);

  // Visibility accessors
  bool getVisibility () { return bVisibility; }
  void setVisibility (gboolean visible)
  {
	bVisibility = visible;
	
	// Keep on foreground
	set_keep_above (true);

	if (visible == true)
	  {
		show ();
		// FIXME: use present to set on top
	  }
	else
	  hide ();
  }

  enum Severity
	{
	  SEVERITY_NORMAL =	0,	// bulgreen
	  SEVERITY_MEDIUM,		// bulyellow
	  SEVERITY_HIGH			// bulred
	};

  std::string getSeverityIcon(int eventSeverity);

private:
  class ModelColumns : public Gtk::TreeModel::ColumnRecord
  {
  public:
	ModelColumns()
    { add(eventIcon); add(eventDate); add(eventText); }
	
	Gtk::TreeModelColumn< Glib::RefPtr<Gdk::Pixbuf> >  eventIcon;
	Gtk::TreeModelColumn<Glib::ustring> eventDate;
	Gtk::TreeModelColumn<Glib::ustring> eventText;
  };

  Glib::RefPtr<Gtk::ListStore> refListModel;
  ModelColumns eventColumns;

  void on_EventWin_hide ();
  bool on_EventWin_focus_out_event (GdkEventFocus* event);
  bool on_EventWin_unmap_event(GdkEventAny* event);

  // is the events GUI currently visible
  bool bVisibility;

private:
 // Stores the previous status for change comparison
  Glib::ustring prevStatus;
};
#endif
