
#include "MgeProgressBar.h"
#include "MainWindow.hh"

MgeProgressBar::MgeProgressBar()
{
  imgPgbBg = Gdk::Pixbuf::create_from_file(mainWinPtr->find_pixmap_file ("bar_bkgnd.png"));
  imgPgbFg = Gdk::Pixbuf::create_from_file(mainWinPtr->find_pixmap_file ("bar.png"));
  // FIXME: display ???
  // imgBase = new class Gtk::Image(imgPgbBg);
}

MgeProgressBar::MgeProgressBar(Gtk::Image *imgBattCharge)
{
  imgBase = imgBattCharge;
  imgPgbBg = Gdk::Pixbuf::create_from_file(mainWinPtr->find_pixmap_file ("bar_bkgnd.png"));
  imgPgbFg = Gdk::Pixbuf::create_from_file(mainWinPtr->find_pixmap_file ("bar.png"));
  hide();
}

static int test = 0;

/// Accessors
/// We only wrap access to the predefined image
void MgeProgressBar::setFraction(int battPercentage)
{
  // FIXME: why img* seems to be overloaded bu copy_area??
  imgPgbBg = Gdk::Pixbuf::create_from_file(mainWinPtr->find_pixmap_file ("bar_bkgnd.png"));
  imgPgbFg = Gdk::Pixbuf::create_from_file(mainWinPtr->find_pixmap_file ("bar.png"));
  Glib::RefPtr<Gdk::Pixbuf> imgCurrentCharge = imgPgbBg; // = new Glib::RefPtr<Gdk::Pixbuf>(imgPgbBg);
  int newImgPercentage = imgPgbBg->get_width () * battPercentage / 100;

  std::cout << "setFraction(" << battPercentage << " %): => new size: " << newImgPercentage << " pix" << std::endl;

  imgPgbFg->copy_area(0, 0,										// int src_x, int src_y
					  newImgPercentage, imgPgbBg->get_height(),	// int width, int height
					  imgCurrentCharge, 0, 0);					// dest_pixbuf, int dest_x, int dest_y

  imgBase->set (imgCurrentCharge);
  imgBase->show();
}

void MgeProgressBar::hide()
{
  /// Only hide (== clear) the base image
  imgBase->clear(); 
}
