// generated 2004/12/15 16:45:06 CET by arno@debian.mgeintra.com.(none)
// using glademm V2.5.0
//
// newer (non customized) versions of this file go to StatusView.cc_new

// This file is for your program, I won't touch it again!

#include <gdkmm.h>

#include "config.h"
#include "gettext.h"
#include "StatusView.hh"

// FIXME: a supprimer
#include "MainWindow.hh"
#include "models.h"


StatusView::StatusView()
  :View("status") //, sysTray(0)
{
  nutClient = new class NutClient(); 

  firstTime = true;

  // Final beautification
  mgePgBar = new MgeProgressBar(imgBattCharge);
  evtWin = new EventWin(_("dummy"));

  // Create the systray icon if needed
  sysTray = NULL;
  manageSysTray();

  // FIXME: get from ConfigView...
  //  sysTray->setVisibility(mainWinPtr->configDlg->nutConfig->getDisplaySystray());


  // Hide all values
  setComFault();

  //  nutClient = new class NutClient(); 
}

void StatusView::manageSysTray()
{
  if (!sysTray)
	{
	  // Create the systray icon if needed
	  if (mainWinPtr->configDlg->nutConfig->getDisplaySystray() == true)
		{
		  std::cout << "Systray has to be created..." << std::endl;
		  sysTray = new MgeSystemTray(Gtk::Image(mainWinPtr->find_pixmap_file ("mgeops-psp-22.png")).get_pixbuf()  );
		  sysTray->setTooltip("Personal Solution Pac");
		  sysTray->setVisibility(true);
		  //		  sysTray->setVisibility(false);
		  sysTray->show_all_children();  // FIXME: needed
		  sysTray->show(); // FIXME: needed
		}
	  else
		sysTray = NULL;
	}
  else
	{
	  // Or destroy it if not needed anymore
	  if (mainWinPtr->configDlg->nutConfig->getDisplaySystray() == false)
		{
		  std::cout << "Systray has to be destroyed..." << std::endl;
		  sysTray->setVisibility(false);
		  delete sysTray;
		  sysTray = NULL;
		}
	}
}

void StatusView::setComFault()
{
  imgStatus->set(mainWinPtr->find_pixmap_file ("com_fault32.png"));
  // Unset all values
  lblModelName->set_text("");
  lblModelDesc->set_text("");
  imgModel->clear();
  lblComStatusValue->set_text("");
  lblPwrSrcValue->set_text("");
  lblBattStatValue->set_text("");
  lblOutputStatValue->set_text("");
  imgOutputMain->clear (); //hide();
  lblLoadValue->set_text("");
  lblRuntimeValue->set_text("");
  lblBattChargeValue->set_text("");
  mgePgBar->hide(); //mgePgBar->setFraction(0);

  // Outlets
  lblOutlet1->set_text("");
  lblOutlet1StatValue->set_text("");
  imgOutlet1->clear (); //hide();
  lblOutlet2->set_text("");
  lblOutlet2StatValue->set_text("");
  imgOutlet2->clear (); //hide();

  lblTestValue->set_text("");

  // sysTray
  manageSysTray();

  if (sysTray)
	{
	  sysTray->setImage(mainWinPtr->find_pixmap_file ("com_fault22.png"));
	  // FIXME
	  sysTray->setTooltip(_("Communication failure"));
	}

  if (firstTime != true)
	evtWin->addEvent(_("Communication failure"), EventWin::SEVERITY_MEDIUM);
//   else
// 	{
// 	  // Force Communication failure exposure
// 	  if (evtWin == NULL)
// 		{
// 		  evtWin = new EventWin(_("dummy"));
// 		  //		  evtWin->addEvent(_("Communication failure"));
// 		}
// 	}

  // Set the reinit flag
  firstTime = true;
}

bool StatusView::refreshView()
{
  // Battery Status frame
  std::string *tmpString = new std::string(); //nutConnexion->getVar("battery.charge"));
  std::ostringstream oss; 
  double fraction;
  //  bool firstTime = true;
  int runtimeHours, runtimeMinutes, runtimeSeconds;

  std::cout << "Refreshing NutView" << std::endl;

  //for(;;) {
	try {
	  // Acquire Read 	Lock on data
	  nutClient->lockVars();
	  
	  if (nutClient->commStatus->compare(_("OK")) != 0) {

		// Hide all values
		setComFault();

	  } else {
		// UPS frame
		//----------
		//		if (firstTime == true) {
		  lblModelName->set_text(*nutClient->upsModel);
// 		  lblModelDesc->set_text(*nutClient->upsDescription); 
		  imgModel->set(mainWinPtr->find_pixmap_file (getModelImage(*nutClient->upsModel)));
		  // firstTime = false;
		  //		}
		
		// Dynamic labels
		// ==============
		// UPS Status frame
		//-----------------
		  lblComStatusValue->set_text(_(nutClient->commStatus->c_str()));
		lblPwrSrcValue->set_text(_(nutClient->upsStatus->c_str()));
		std::cout << "==============> upsStatus = " << nutClient->upsStatus->c_str() << std::endl;
		if (nutClient->upsStatus->compare(0, 2, "AC") == 0)
		  {
			imgStatus->set(mainWinPtr->find_pixmap_file ("on_ac32.png"));

			// sysTray
			manageSysTray();
			if (sysTray)
			  {
				sysTray->setImage(mainWinPtr->find_pixmap_file ("on_ac22.png"));
				// FIXME
				sysTray->setTooltip(_("AC Power"));
			  }

			if (firstTime != true)
			  evtWin->addEvent(_("Utility restored"));
// 			else
// 			  evtWin = new EventWin(_("Utility restored"));
		  }
		else
		  {
			// FIXME: address bat_fault (status ?)	
			imgStatus->set(mainWinPtr->find_pixmap_file ("on_bat32.png"));

			if (firstTime != true)
			  evtWin->addEvent(_("Utility failure"), EventWin::SEVERITY_MEDIUM);
// 			else
// 			  evtWin = new EventWin(_("Utility failure"));

			// sysTray
			manageSysTray();
			if (sysTray)
			  {
				if (nutClient->batteryCharge >= 76)
				  sysTray->setImage(mainWinPtr->find_pixmap_file ("systray_bat_100.png"));
				else
				  {
					if (nutClient->batteryCharge >= 51)
					  sysTray->setImage(mainWinPtr->find_pixmap_file ("systray_bat_075.png"));
					else
					  {
						if (nutClient->batteryCharge >= 26)
						  sysTray->setImage(mainWinPtr->find_pixmap_file ("systray_bat_050.png"));
						else
						  {
							if (nutClient->batteryCharge >= 1)
							  sysTray->setImage(mainWinPtr->find_pixmap_file ("systray_bat_025.png"));
							else // the 0 level is only if batt.charge == 0
							  sysTray->setImage(mainWinPtr->find_pixmap_file ("systray_bat_000.png"));
						  }
					  }
				  }
				// FIXME
				sysTray->setTooltip(_("Battery"));
			  }
		  }
		

		lblBattStatValue->set_text(_(nutClient->battStatus->c_str()));
		
		
		/// Set load on output
		oss.str("");
		oss << nutClient->outputLoad << " %"; 
		lblLoadValue->set_text(oss.str());
	  
		/// Set Master Output status
		  if (nutClient->outputStatus->compare(0, 3, "Bypass") == 0)
		  {
			imgOutputMain->set(mainWinPtr->find_pixmap_file ("output_off.png"));
			lblOutputStatValue->set_text(_("On"));
		  }
		else
		  {
			lblOutputStatValue->set_text(_(nutClient->outputStatus->c_str()));

			if (nutClient->outputStatus->compare(0, 3, "Off") == 0)
			  {
				imgOutputMain->set(mainWinPtr->find_pixmap_file ("output_off.png"));
			  } else
			  {
				imgOutputMain->set(mainWinPtr->find_pixmap_file ("output_on.png"));
			  }
		  }
		imgOutputMain->show();

		/// Check if Outlet1 exists, and if it's On or Off
		if (nutClient->outlet1Status->compare(0, 4, "none") == 0)
		  {
			// If none, set position to x=155 and blank / hide the rest
			lblOutlet1->set_text(_("none"));
   		lblOutlet1->set_size_request(50,16);
			fixed4->move(*lblOutlet1, 155, 97);
			lblOutlet1StatValue->set_text("");
			imgOutlet1->hide();
		  }
		else // Check if outlet1/2 exists, and are On or Off
		  {
			// Outlet1
			//fixed4->move(*lblOutlet1, 130, 97);
			fixed4->move(*lblOutlet1, 139, 97);
			lblOutlet1->set_text(_("1:"));
			if ((nutClient->outlet1Status->compare(0, 1, "1") == 0) ||
				(nutClient->outlet1Status->compare(0, 2, "on") == 0))
			  {
				lblOutlet1StatValue->set_text(_("On"));
				imgOutlet1->set(mainWinPtr->find_pixmap_file ("output_on.png"));
			  }
			else
			  {
				lblOutlet1StatValue->set_text(_("Off"));
				imgOutlet1->set(mainWinPtr->find_pixmap_file ("output_off.png"));
			  }		
		  }

		// Check if Outlet2 exists, and if it's On or Off
		if (nutClient->outlet2Status->compare(0, 4, "none") == 0)
		  {
			lblOutlet2->set_text("");
			lblOutlet2StatValue->set_text("");
			imgOutlet2->hide();			
		  }
		else
		  {
			lblOutlet2->set_text(_("2:"));
			if ((nutClient->outlet2Status->compare(0, 1, "1") == 0) ||
				(nutClient->outlet2Status->compare(0, 2, "on") == 0))
			  {
				lblOutlet2StatValue->set_text(_("On"));
				imgOutlet2->set(mainWinPtr->find_pixmap_file ("output_on.png"));
			  }
			else
			  {
				lblOutlet2StatValue->set_text(_("Off"));
				imgOutlet2->set(mainWinPtr->find_pixmap_file ("output_off.png"));
			  }
		  }

		// Battery Status frame
		// Battery runtime
		oss.str("");		
		oss.precision(2);
		runtimeHours = nutClient->batteryRuntime / 3600;
		runtimeMinutes = (nutClient->batteryRuntime - (runtimeHours * 3600)) / 60;
		runtimeSeconds = nutClient->batteryRuntime % 60;

		char runtimeTotal[20];

		if (runtimeHours > 0)
		  {
			if (runtimeMinutes > 0)
			  sprintf(&runtimeTotal[0], "%i h %02i mn %02i s", runtimeHours, runtimeMinutes, runtimeSeconds);
		  }
		else
		  sprintf(&runtimeTotal[0], "%02i mn %02i s", runtimeMinutes, runtimeSeconds);

// 		std::cout << "Runtime = " << oss.str() << std::endl;
// 		lblRuntimeValue->set_text(oss.str());

		lblRuntimeValue->set_text(runtimeTotal);


		// Battery charge
		oss.str("");
		oss << nutClient->batteryCharge << " %";
		lblBattChargeValue->set_text(oss.str());
		mgePgBar->setFraction(nutClient->batteryCharge);
	  
		// FIXME(h2 determine it?): Last periodic test result
		// FIXME: if "Unknown", don't display!
		if ( (nutClient->testResult->compare(0, 7, "Unknown") == 0)
			|| (nutClient->testResult->compare(0, 1, "0") == 0) )
		  {
				lblTestValue->hide();
				lblLastPeriodicTest->hide();
				// FIXME: strech lower frmBattStat border?
		  }
		else
		  lblTestValue->set_text(*nutClient->testResult);

	  } // else
	} catch (Glib::Exception& e) 
	  { 
		// FIXME: real exception handling code
	  }
	
	// Release Read Lock on data
	nutClient->releaseVars();

	if (firstTime == true)
	  firstTime = false;

	return true;
}


std::string StatusView::getModelImage(const std::string modelName)
{
  upsGfx *item;
  std::string lcModelName = (Glib::ustring(modelName).lowercase()).raw();
  
  std::cout << "getModelImage(" << modelName << std::endl;

  for ( item = upsImages ; item->upsName != "null" ; item++ )
	{
	  std::cout << "Comparing with " << item->upsName << std::endl;

	  // Lower Case comparison to avoid case problem
	  if ((Glib::ustring(modelName).lowercase()).raw().compare(0, modelName.length(),
							  (Glib::ustring(item->upsName).lowercase()).raw()) == 0)
		{
		  std::cout << "found " << item->upsName << std::endl;
		  break;
		}
	}
  return item->gfxName;
}

void StatusView::setFont(const Glib::ustring fontName)
{
  get_style()->set_font(Pango::FontDescription(fontName));

  // Static labels
  lblUps->modify_font(Pango::FontDescription(fontName));
  lblUpsStatus->modify_font(Pango::FontDescription(fontName));
  lblBattStatus->modify_font(Pango::FontDescription(fontName));
  lblComStatus->modify_font(Pango::FontDescription(fontName));
  lblPwrSrc->modify_font(Pango::FontDescription(fontName));
  lblBattStat->modify_font(Pango::FontDescription(fontName));
  lblLoad->modify_font(Pango::FontDescription(fontName));
  lblOutputStat->modify_font(Pango::FontDescription(fontName));
  lblOutlets->modify_font(Pango::FontDescription(fontName));
  lblBattCharge->modify_font(Pango::FontDescription(fontName));
  lblRuntime->modify_font(Pango::FontDescription(fontName));
  lblLastPeriodicTest->modify_font(Pango::FontDescription(fontName));

  // Dynamic labels
  lblComStatusValue->modify_font(Pango::FontDescription(fontName));
  lblPwrSrcValue->modify_font(Pango::FontDescription(fontName));
  lblOutlet1->modify_font(Pango::FontDescription(fontName));
  lblOutlet2->modify_font(Pango::FontDescription(fontName));
  lblOutlet1StatValue->modify_font(Pango::FontDescription(fontName));
  lblOutlet2StatValue->modify_font(Pango::FontDescription(fontName));
  lblOutputStatValue->modify_font(Pango::FontDescription(fontName));
  lblLoadValue->modify_font(Pango::FontDescription(fontName));
  lblBattStatValue->modify_font(Pango::FontDescription(fontName));
  lblBattChargeValue->modify_font(Pango::FontDescription(fontName));
  lblRuntimeValue->modify_font(Pango::FontDescription(fontName));
  lblTestValue->modify_font(Pango::FontDescription(fontName));
  lblModelName->modify_font(Pango::FontDescription(fontName));
  lblModelDesc->modify_font(Pango::FontDescription(fontName));

  // "Children" view
  evtWin->setFont(fontName);

  cout << "=========> Font used: " << lblComStatusValue->get_style()->get_font().to_string() << endl;
}
