/***************************************************************************
 *   Copyright (C) 2004 by MGE UPS SYSTEMS                                 *
 *   arnaud.quette@mgeups.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef _VIEW_HH
#  include <gtkmm.h>
#  include <glibmm.h>
#  define _VIEW_HH

#include <iostream>

class View
 {
 	public:
		// Constructeurs
		View() {  };
		View(char *name)
		  { 
			viewName = name;
			std::cout << "creating view: " << viewName << std::endl;
		  };

		~View() {};
		
		char *getName() { return viewName; };
		bool setName(char *name) { return false; };
		
		// Graphical content accessors
		virtual Gtk::Widget *getViewContent() = 0;
		virtual Gtk::Widget *getViewPort() = 0;
		virtual bool refreshView() = 0;
		virtual void setFont(const Glib::ustring fontName) = 0;

	protected:
		 char *viewName;
 };

#endif
